//--------------------------------------
// VST Plug-Ins SDK 
// BALANCE
//
// Francisco Javier Ripoll Esteve
// ripollete@hotmail.com
// 13/05/2008
//--------------------------------------

#include "balance.h"


#ifndef __again__
#define __again__

#include "public.sdk/source/vst2.x/audioeffectx.h"


enum {
	NumeroProgramBalance, 
	kNumParams
};

class ABalance : public AudioEffectX {
public:
	ABalance (audioMasterCallback audioMaster);
	~ABalance ();

	// Proces
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
	virtual void processDoubleReplacing (double** inputs, double** outputs, VstInt32 sampleFrames);

	// Parametres
	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char* label);
	virtual void getParameterDisplay (VstInt32 index, char* text);
	virtual void getParameterName (VstInt32 index, char* text);

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion ();

protected:
	float fBalance;
	char programName[kVstMaxProgNameLen+1];
};

#endif
