//--------------------------------------
// VST Plug-Ins SDK 
// DELAY
//
// Francisco Javier Ripoll Esteve
// ripollete@hotmail.com
// 13/05/2008
//--------------------------------------

#ifndef __again__
#define __again__

#include "public.sdk/source/vst2.x/audioeffectx.h"


enum {
	kDelay = 0,
	kDryWet,
	kOut,
	kNumParams
};


class ADelay;


class ADelay : public AudioEffectX {

public:
	ADelay (audioMasterCallback audioMaster);
	~ADelay ();

	virtual void processReplacing (float **inputs, float **outputs, VstInt32 sampleFrames);
	virtual void processDoubleReplacing (double** inputs, double** outputs, VstInt32 sampleFrames);

	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char *label);
	virtual void getParameterDisplay (VstInt32 index, char *text);
	virtual void getParameterName (VstInt32 index, char *text);

	virtual void resume ();

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion () { return 1000; }
	
	virtual VstPlugCategory getPlugCategory () { 
		return kPlugCategEffect; 
	}

protected:
	void setDelay (float delay);
	
	float *buffer1;
	float *buffer2;
	double *buffer1d;
	double *buffer2d;
	float fDelay, fDryWet,fOut;
	
	int delay;
	int L;
	long posicion;
};

#endif
