//--------------------------------------
// VST Plug-Ins SDK 
// DISTORSI
//
// Francisco Javier Ripoll Esteve
// ripollete@hotmail.com
// 13/05/2008
//--------------------------------------

#ifndef __ADistorsio__
#define __ADistorsio__

#include "public.sdk/source/vst2.x/audioeffectx.h"


enum {
	kDistorsio = 0,
	kGain,
	kNumParams
};


class ADistorsio : public AudioEffectX {
public:
	ADistorsio (audioMasterCallback audioMaster);
	~ADistorsio ();


	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
	virtual void processDoubleReplacing (double** inputs, double** outputs, VstInt32 sampleFrames);

	virtual void setProgramName (char* name);
	virtual void getProgramName (char* name);

	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char* label);
	virtual void getParameterDisplay (VstInt32 index, char* text);
	virtual void getParameterName (VstInt32 index, char* text);

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion ();

protected:
	float fGain;
	float iDistorsio;
	float fDistorsio;
	char programName[kVstMaxProgNameLen+1];
	float MaxBits;
	float MinBits;
};

#endif
