//--------------------------------------
// VST Plug-Ins SDK 
// GENERADOR
//
// Francisco Javier Ripoll Esteve
// ripollete@hotmail.com
// 06/06/2008
//--------------------------------------

#ifndef __again__
#define __again__

#include "public.sdk/source/vst2.x/audioeffectx.h"

const	float	FreqMax = 20000; // 20 kHz
const	float	FreqMin = 20; // 20 Hz


enum {
	kFrequencia = 0,
	kAmplitud,
	kForma
};

enum{
	FormaSinus = 0,
	FormaQuadra,
	FormaTriangle,
	NombreDeFormes
};


class AGenerador;


class AGenerador : public AudioEffectX {

public:
	AGenerador (audioMasterCallback audioMaster);
	~AGenerador ();

	virtual void processReplacing (float **inputs, float **outputs, VstInt32 sampleFrames);

	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char *label);
	virtual void getParameterDisplay (VstInt32 index, char *text);
	virtual void getParameterName (VstInt32 index, char *text);

	virtual void resume ();

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion () { return 1000; }
	
	virtual VstPlugCategory getPlugCategory () { 
		return kPlugCategEffect; 
	}

protected:

	float fAmplitud, fFrequencia;
	int fForma;
	int tipus;
	double i;
	float f;
	float pi;

};

#endif
