//--------------------------------------
// VST Plug-Ins SDK 
// SINTETISADOR
//
// Francisco Javier Ripoll Esteve
// ripollete@hotmail.com
// 18/06/2008
//--------------------------------------

#ifndef __again__
#define __again__

#include "public.sdk/source/vst2.x/audioeffectx.h"

const	float	FreqMax = 20000; // 20 kHz
const	float	FreqMin = 20; // 20 Hz


enum {
	kForma =0,
	kAttack,
	kDecay,
	kRelease,
	kSustain,
	kTecles
};

enum {
	FormaSinus = 0,
	FormaQuadra,
	FormaTriangle,
	NombreDeFormes
};

enum {
	EOff = 0,
	EAttack,
	EDecay,
	ESustain,
	ERelease
};

struct nota_struct {
	bool noteIsOn;
	VstInt32 currentNote;
	VstInt32 Velocity;
	VstInt32 Delta;
	float fPhase1, fPhase2;
	int estat;
	int CAttack, CDecay, CRelease;
	float NoteFreq;
	float salida;

};


class ASinteti;


class ASinteti : public AudioEffectX {

public:
	ASinteti (audioMasterCallback audioMaster);
	~ASinteti ();

	virtual void processReplacing (float **inputs, float **outputs, VstInt32 sampleFrames);
	virtual VstInt32 processEvents (VstEvents* events);

	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char *label);
	virtual void getParameterDisplay (VstInt32 index, char *text);
	virtual void getParameterName (VstInt32 index, char *text);

	virtual void resume ();

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion () { return 1000; }
	
	virtual VstPlugCategory getPlugCategory () { 
		return kPlugCategEffect; 
	}

protected:

	
	int fForma;
	double i;
	float f;
	float pi;
	nota_struct nota[85];
	float volum;
	int TeclesMaximes;
	float TTeclesMaximes;
	int TeclesActives;

	/*float fPhase1, fPhase2;
	VstInt32 currentNote;
	VstInt32 currentVelocity;
	VstInt32 currentDelta;
	bool noteIsOn;*/

	//int estat;
	float TAttack, TDecay,TRelease, PSustain;
	float fHeadRoom;
	//int CAttack, CDecay, CRelease;

	float conversorPosicionenFrecuencia(int j);
	int conversorNotaenPosicion(VstInt32 Nota);
	void noteOn (VstInt32 note, VstInt32 velocity, VstInt32 delta);
	void noteOff (VstInt32 note);
	void noteOffAll();
	void initProcess ();

};

#endif
